//-----------------------------------------------------------------------------
#ifndef SerCamApiExceptionsH
#define SerCamApiExceptionsH SerCamApiExceptionsH
//-----------------------------------------------------------------------------

namespace mv {

//-----------------------------------------------------------------------------
class ESerCamApi
//-----------------------------------------------------------------------------
{
	std::string		m_errorString;
	int				m_errorCode;
protected:
	void setErrString( const std::string& errorString ) { m_errorString = errorString; }
public:
	ESerCamApi( const std::string& errstr, int errcode ) : m_errorString(errstr), m_errorCode(errcode) {}
	virtual ~ESerCamApi() {}
	const std::string&	errString( void ) const { return m_errorString; }
	int					errCode( void ) const { return m_errorCode; }
};

//-----------------------------------------------------------------------------
enum TSCAErrorCodes
//-----------------------------------------------------------------------------
{
	SCA_COMTIMEOUT = -5000,
	SCA_MSGLENGTH = -5001,
	SCA_NOPORTOPEN = -5002,
	SCA_COMWRITEERROR = -5004,
	SCA_BUFFERSIZE = -5005,
	SCA_FUNCNOTFOUND = -5006,
	SCA_PARAMETER = -5007,
	SCA_WRONG_COMMAND_ID = -5008,
	SCA_XOR_ERROR = -5009,
	SCA_FUNC_CALL_FAILED = -5010,
	SCA_FILE_ACCESS_ERROR = -5011
};

//-----------------------------------------------------------------------------
class EComTimeout : public ESerCamApi
//-----------------------------------------------------------------------------
{
public:
	explicit EComTimeout() : ESerCamApi("communication timeout", SCA_COMTIMEOUT ) {}
};

//-----------------------------------------------------------------------------
class EMessageLength : public ESerCamApi
//-----------------------------------------------------------------------------
{
public:
	explicit EMessageLength( const std::string& errstr ) : ESerCamApi(errstr, SCA_MSGLENGTH ) {}
};

//-----------------------------------------------------------------------------
class EFunctionNotFound : public ESerCamApi
//-----------------------------------------------------------------------------
{
public:
	explicit EFunctionNotFound() : ESerCamApi("function not found", SCA_FUNCNOTFOUND ) {}
};

//-----------------------------------------------------------------------------
class EComWrite : public ESerCamApi
//-----------------------------------------------------------------------------
{
public:
	explicit EComWrite() : ESerCamApi("com write failure", SCA_COMWRITEERROR ) {}
};

//-----------------------------------------------------------------------------
class EBufferSize : public ESerCamApi
//-----------------------------------------------------------------------------
{
public:
	explicit EBufferSize() : ESerCamApi("buffer size too small", SCA_BUFFERSIZE ) {}
};

//-----------------------------------------------------------------------------
class EParameter : public ESerCamApi
//-----------------------------------------------------------------------------
{
public:
	explicit EParameter() : ESerCamApi("Parameter error", SCA_PARAMETER ) {}
	explicit EParameter( const std::string& errstr ) : ESerCamApi(errstr, SCA_PARAMETER ) {}
};


} // namespace mv

#endif // SerCamApiExceptionsH
